/**************************************************************************
*             Exercice de dmultiplication de port via 74HC595            *
*             Sortie sur 24 LEDs.          PIC16F876A  MikroC             *
*             3 Ports pour 24 sorties avec 3x 74HC595                     *
*              Chaque circuit ajout permet 8 ports supplmentaires       *
*                     FB Aka Hearty Juillet 2010                          *
**************************************************************************/

//*****************
//Dclaration des variables
int i,vitesse;
char HC595_0,HC595_1,HC595_2;

// Tableau de figure sur 8 bits installs en ROM
const char sequence[]={
    0b00000000, 0b00000000, 0b00000000,
    0b00000000, 0b00000000, 0b00000001, // LED allume = 1 -- HC595_0, HC595_1, HC595_2
    0b00000000, 0b00000000, 0b00000010,
    0b00000000, 0b00000000, 0b00000100,
    0b00000000, 0b00000000, 0b00001000,
    0b00000000, 0b00000000, 0b00010000,
    0b00000000, 0b00000000, 0b00100000,
    0b00000000, 0b00000000, 0b01000000,
    0b00000000, 0b00000000, 0b10000000,
    0b00000000, 0b00000001, 0b00000000,
    0b00000000, 0b00000010, 0b00000000,
    0b00000000, 0b00000100, 0b00000000,
    0b00000000, 0b00001000, 0b00000000,
    0b00000000, 0b00010000, 0b00000000,
    0b00000000, 0b00100000, 0b00000000,
    0b00000000, 0b01000000, 0b00000000,
    0b00000000, 0b10000000, 0b00000000,
    0b00000001, 0b00000000, 0b00000000,
    0b00000010, 0b00000000, 0b00000000,
    0b00000100, 0b00000000, 0b00000000,
    0b00001000, 0b00000000, 0b00000000,
    0b00010000, 0b00000000, 0b00000000,
    0b00100000, 0b00000000, 0b00000000,
    0b01000000, 0b00000000, 0b00000000,
    0b10000000, 0b00000000, 0b00000000
      };
//******************************************************************************
//Interruption
void interrupt() {
  vitesse++;
  TMR0   = 0;             // Valeur dcimale prcharge  soustraire  256
//********************
//Dsactive l'interruption TMR0   (0xA0 = active)
  INTCON = 0x20;         // Set T0IE, clear T0IF (Met  1 le bit TMROIE , Efface(0) le Flag TMROIF de dbordement d'interruption)
                 }       //fin interruption

//******************************************************************************


void send_data(char HC595_0, char HC595_1, char HC595_2)
{
  Spi1_Write(HC595_0);     // donnes premier circuit
  Spi1_Write(HC595_1);     // donnes deuxime circuit
  Spi1_Write(HC595_2);     // donnes troisime circuit
  PORTC.F6=1;             // impulsion de validation sur LATCH
  PORTC.F6=0;
}
//******************************************************************************
// Programme principal
void main(){

  INTCON=0xA0;                      // Activer l'interruption TMR0
  OPTION_REG = 0x00;                // Assigner prescaler sur TMR0  valeur 2   = 000
  TMR0=0;
  ADCON0=0;                         // ADC dsactiv
  TRISA=1;                          // PORTA configur en Entre
  TRISB=0;                          // PORTB configur en sortie
  TRISC=0;                          // PORTC configur en sortie
  PORTA=0;                          // mise  zro des ports A
  PORTB=0;                          // mise  zro des ports B
  PORTC=0;                          // mise  zro des ports C
  vitesse=0;                        // vitesse de dfilement
  i=0;

//Paramtre de configuration des ports pour la gestion du 74HC595
  SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16,_SPI_DATA_SAMPLE_MIDDLE,_SPI_CLK_IDLE_LOW,_SPI_LOW_2_HIGH);

//******************************************************************************
//boucle infinie
      while(1)
             {
            if(vitesse==512){
            vitesse=0;
             if(i==24)           // compteur sur la totalit des octets du tableau
              {
                i=0;
                 }  // fin de If
                  i++;
              HC595_0=sequence[i*3];       // donnes sur le premier 595
              HC595_1=sequence[(i*3)+1];   // donnes sur le second 595
              HC595_2=sequence[(i*3)+2];   // donnes sur le troisime 595
              send_data(HC595_0,HC595_1,HC595_2);   // envoie les donnes  afficher


                          } // fin de If

           }  //fin de while

}  // fin de main

//***************************************************************************

